*     JLdL 26May06.
*     Copyright (C) 1999-2006 by Jorge L. deLyra.
*     Mail: <delyra@latt.if.usp.br>. Web: "http://latt.if.usp.br".
*     This program may be copied and/or distributed freely. See the
*     _ terms and conditions in the files in the doc/ subdirectory.
*     
*     Use the prop_d[1-4] subroutines to calculate the propagator of
*     _ the free theory, for various values of dimension and mass.
*     
      PROGRAM PROPS
*     
*     Double precision everything.
      implicit double precision (a-h,o-z)
*     
*     Read the dimension and the mass without prompting.
      read(*,*) ndim,amass
*     
*     Cannot use exactly zero for the mass, so use a very small number.
      if (amass.eq.0.0d0) amass=1.0d-66
*     
*     Call the appropriate routine with the appropriate argument.
      if (ndim.eq.1) then
         call prop_d1(amass)
      else if (ndim.eq.2) then
         call prop_d2(amass)
      else if (ndim.eq.3) then
         call prop_d3(amass)
      else if (ndim.eq.4) then
         call prop_d4(amass)
      else
         stop 'green: ERROR: cannot calculate for d larger than 4'
      end if
*     
      END
